"use strict";
var Select = (function () {
    function Select(elementRef, zone) {
        this.elementRef = elementRef;
        this.zone = zone;
        this.indiceId = 'id';
        this.indiceNome = 'nome';
        this.aberto = false;
        this.resultadoCompleto = false;
        this.focus = false;
        this.valoresExibir = [];
    }
    Select.prototype.setFocus = function (valor) {
        this.focus = valor;
    };
    Select.prototype.fechar = function () {
        this.aberto = false;
        this.setFocus(false);
    };
    Select.prototype.selecionar = function (item) {
        if (this.resultadoCompleto) {
            this.updateValue(this.data);
        }
        else {
            this.updateValue(this.data[this.indiceId]);
        }
        this.fechar();
        //apaga campo de busca
        this.campoBusca.nativeElement.value = '';
    };
    /**
     * quando está marcado para exibir resultado completo
     */
    Select.prototype.remove = function (item) {
        var _this = this;
        // let itens
        var posicao = this.data.findIndex(function (procurar) { return procurar[_this.indiceId] == item[_this.indiceId]; });
        if (posicao !== -1) {
            this.data.splice(posicao, 1);
        }
    };
    Select.prototype.getClassGeral = function () {
        if (this.focus) {
            return 'select2 select2-container select2-container--bootstrap select2-container--above select2-container--focus';
        }
        else {
            return 'select2 select2-container select2-container--bootstrap select2-container--above';
        }
    };
    Select.prototype.clickForaComponent = function (event) {
        if (!this.elementRef.nativeElement.contains(event.target) && this.aberto) {
            this.fechar();
        }
    };
    Select.prototype.writeValue = function (value) {
        this.data = value;
        this._value = value;
    };
    Select.prototype.updateValue = function (value) {
        var _this = this;
        this.zone.run(function () {
            _this._value = value;
            _this.onChange(value);
            _this._onTouchedCallback();
            _this.change.emit(value);
        });
    };
    Select.prototype.onChange = function (_) { };
    Select.prototype.onTouched = function () { };
    Select.prototype.registerOnChange = function (fn) { this.onChange = fn; };
    Select.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
    Select.prototype._onChangeCallback = function (_) { };
    Select.prototype._onTouchedCallback = function () { };
    return Select;
}());
exports.Select = Select;
//# sourceMappingURL=select.js.map